//+------------------------------------------------------------------+
//|                                            Heiken Ashi Ma T3.mq4 |
//+------------------------------------------------------------------+
//|                                                      mod by Raff |
//|                                               2009 mod by mladen |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008,Forex-TSD.com"
#property link      "http://www.forex-tsd.com/"

#property indicator_chart_window
#property indicator_buffers 7
//#property indicator_color1 PaleVioletRed
//#property indicator_color2 DeepSkyBlue
#property indicator_color3 PaleVioletRed
#property indicator_color4 DeepSkyBlue
#property indicator_color5 PaleVioletRed
#property indicator_color6 DeepSkyBlue
#property indicator_width1 1
#property indicator_width2 1
#property indicator_width3 2
#property indicator_width4 2
#property indicator_width5 1
#property indicator_width6 1

//
//
//
//
//

extern string TimeFrame       = "0";
extern int    MaMetod         = 2;
extern int    MaPeriod        = 6;
extern int    Step            = 1;
extern bool   BetterFormula   = true;
extern int    T3Period        = 9;
extern bool   T3Average       = false;
extern double T3Hot           = 0.70;
extern bool   T3Original      = false;
extern bool   ShowArrows      = False;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = true;
extern bool   alertsMessage   = true;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   Interpolate     = true;

//
//
//
//
//

double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ExtMapBuffer3[];
double ExtMapBuffer4[];
double UpArrow[];
double DnArrow[];
double trend[];

//
//
//
//
//

double emas[][24];
double alpha;
double c1;
double c2;
double c3;
double c4;

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;



//+------------------------------------------------------------------+
//|                                                                  |
//|------------------------------------------------------------------|
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0, ExtMapBuffer1); SetIndexStyle(0,CLR_NONE); SetIndexLabel(0,"HAMAExb1 TF= "+TimeFrame);
   SetIndexBuffer(1, ExtMapBuffer2); SetIndexStyle(1,CLR_NONE); SetIndexLabel(1,"Exb2");
   SetIndexBuffer(2, ExtMapBuffer3); SetIndexStyle(2,DRAW_HISTOGRAM); SetIndexLabel(2,"Exb3");
   SetIndexBuffer(3, ExtMapBuffer4); SetIndexStyle(3,DRAW_HISTOGRAM); SetIndexLabel(3,"Exb4");
   SetIndexBuffer(4, DnArrow);                                        SetIndexLabel(4,"DnArrow");
   SetIndexBuffer(5, UpArrow);                                        SetIndexLabel(5,"UpArrow");
   SetIndexBuffer(6, trend);                                          SetIndexLabel(6,"HAMA-trend");
    
   //
   //
   //
   //
   //
   
      double a  = T3Hot;
             c1 = -a*a*a;
             c2 =  3*(a*a+a*a*a);
             c3 = -3*(2*a*a+a+a*a*a);
             c4 = 1+3*a+a*a*a+3*a*a;

      T3Period = MathMax(1,T3Period);
      if (T3Original)
           alpha = 2.0/(1.0 + T3Period);
      else alpha = 2.0/(2.0 + (T3Period-1.0)/2.0);

      //
      //
      //
      //
      //
      
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);
         if (ShowArrows)
            {
                SetIndexStyle(4,DRAW_ARROW); SetIndexArrow(4,234);
                SetIndexStyle(5,DRAW_ARROW); SetIndexArrow(5,233);
            }
         else
            {
                SetIndexStyle(4,DRAW_NONE);
                SetIndexStyle(5,DRAW_NONE);
            }

   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   double maOpen, maClose, maLow, maHigh;
   double haOpen, haClose, haLow, haHigh;
   int    i,limit,counted_bars=IndicatorCounted();
   int    pointModifier;

   //
   //
   //
   //
   //

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { ExtMapBuffer1[0] = limit+1; return(0); }
          
   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);
      if (Digits==3 || Digits==5)
            pointModifier = 10;
      else  pointModifier = 1;               
      for(i=limit; i >= 0; i--)
      {
         if (T3Average)
            {
             maOpen  = iT3(Open[i] ,i, 0);
             maClose = iT3(Close[i],i, 6);
             maLow   = iT3(Low[i]  ,i,12);
             maHigh  = iT3(High[i] ,i,18);
            }
         else
            {
             maOpen  = iMA(NULL, 0, MaPeriod, 0, MaMetod,PRICE_OPEN, i);
             maClose = iMA(NULL, 0, MaPeriod, 0, MaMetod,PRICE_CLOSE,i);
             maLow   = iMA(NULL, 0, MaPeriod, 0, MaMetod,PRICE_LOW,  i);
             maHigh  = iMA(NULL, 0, MaPeriod, 0, MaMetod,PRICE_HIGH, i);
            }
   
         //
         //
         //
         //
         //
        
            if (BetterFormula) {
                  if (maHigh!=maLow)
                        haClose = (maOpen+maClose)/2+(((maClose-maOpen)/(maHigh-maLow))*MathAbs((maClose-maOpen)/2));
                  else  haClose = (maOpen+maClose)/2; }
            else        haClose = (maOpen+maHigh+maLow+maClose)/4;
                        haOpen   = (ExtMapBuffer3[i+1]+ExtMapBuffer4[i+1])/2;
                        haHigh   = MathMax(maHigh, MathMax(haOpen,haClose));
                        haLow    = MathMin(maLow,  MathMin(haOpen,haClose));

            if (haOpen<haClose) { ExtMapBuffer1[i]=haLow;  ExtMapBuffer2[i]=haHigh; } 
            else                { ExtMapBuffer1[i]=haHigh; ExtMapBuffer2[i]=haLow;  } 
                                  ExtMapBuffer3[i]=haOpen;
                                  ExtMapBuffer4[i]=haClose;

            //
            //
            //
            //
            //
            
            trend[i] = trend[i+i];
               if (ExtMapBuffer3[i]<ExtMapBuffer4[i]) trend[i] =  1;
               if (ExtMapBuffer3[i]>ExtMapBuffer4[i]) trend[i] = -1;
      
         //
         //
         //
         //
         //

         if (Step>0)
         {
            if( MathAbs(ExtMapBuffer1[i]-ExtMapBuffer1[i+1]) < Step*pointModifier*Point ) ExtMapBuffer1[i]=ExtMapBuffer1[i+1];
            if( MathAbs(ExtMapBuffer2[i]-ExtMapBuffer2[i+1]) < Step*pointModifier*Point ) ExtMapBuffer2[i]=ExtMapBuffer2[i+1];
            if( MathAbs(ExtMapBuffer3[i]-ExtMapBuffer3[i+1]) < Step*pointModifier*Point ) ExtMapBuffer3[i]=ExtMapBuffer3[i+1];
            if( MathAbs(ExtMapBuffer4[i]-ExtMapBuffer4[i+1]) < Step*pointModifier*Point ) ExtMapBuffer4[i]=ExtMapBuffer4[i+1];
         }         
         if (ShowArrows)
         {
               UpArrow[i] = EMPTY_VALUE; 
               DnArrow[i] = EMPTY_VALUE;
               if (trend[i]!=trend[i+1])
               {
                  if (trend[i]== 1) UpArrow[i] = haLow -iATR(NULL,0,20,i)/2.0;
                  if (trend[i]==-1) DnArrow[i] = haHigh+iATR(NULL,0,20,i)/2.0;
               }                  
         }
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         ExtMapBuffer1[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaMetod,MaPeriod,Step,BetterFormula,T3Period,T3Average,T3Hot,T3Original,0,y);
         ExtMapBuffer2[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaMetod,MaPeriod,Step,BetterFormula,T3Period,T3Average,T3Hot,T3Original,1,y);
         ExtMapBuffer3[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaMetod,MaPeriod,Step,BetterFormula,T3Period,T3Average,T3Hot,T3Original,2,y);
         ExtMapBuffer4[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaMetod,MaPeriod,Step,BetterFormula,T3Period,T3Average,T3Hot,T3Original,3,y);
         trend[i]         = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",MaMetod,MaPeriod,Step,BetterFormula,T3Period,T3Average,T3Hot,T3Original,6,y);
         
         //
         //
         //
         //
         //
         
         if (ShowArrows)
         {
            UpArrow[i] = EMPTY_VALUE; 
            DnArrow[i] = EMPTY_VALUE;
            if(trend[i]!=trend[i+1])
            { 
               if (trend[i]== 1) UpArrow[i] = MathMin(ExtMapBuffer1[i],ExtMapBuffer2[i])-iATR(NULL,0,20,i)/2.0;
               if (trend[i]==-1) DnArrow[i] = MathMax(ExtMapBuffer1[i],ExtMapBuffer2[i])+iATR(NULL,0,20,i)/2.0;
            }
         }            
            
         //
         //
         //
         //
         //
      
         if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               ExtMapBuffer1[i+k] = ExtMapBuffer1[i] + (ExtMapBuffer1[i+n]-ExtMapBuffer1[i])*k/n;
               ExtMapBuffer2[i+k] = ExtMapBuffer2[i] + (ExtMapBuffer2[i+n]-ExtMapBuffer2[i])*k/n;
               ExtMapBuffer3[i+k] = ExtMapBuffer3[i] + (ExtMapBuffer3[i+n]-ExtMapBuffer3[i])*k/n;
               ExtMapBuffer4[i+k] = ExtMapBuffer4[i] + (ExtMapBuffer4[i+n]-ExtMapBuffer4[i])*k/n;
            }               
   }
   manageAlerts();
   return(0);         
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iT3(double price, int shift,int buffer)
{
   int i = Bars-shift-1;
   if (i < 1)
      {
         emas[i][0+buffer] = price;
         emas[i][1+buffer] = price;
         emas[i][2+buffer] = price;
         emas[i][3+buffer] = price;
         emas[i][4+buffer] = price;
         emas[i][5+buffer] = price;
      }
   else
      {
         emas[i][0+buffer] = emas[i-1][0+buffer]+alpha*(price            -emas[i-1][0+buffer]);
         emas[i][1+buffer] = emas[i-1][1+buffer]+alpha*(emas[i][0+buffer]-emas[i-1][1+buffer]);
         emas[i][2+buffer] = emas[i-1][2+buffer]+alpha*(emas[i][1+buffer]-emas[i-1][2+buffer]);
         emas[i][3+buffer] = emas[i-1][3+buffer]+alpha*(emas[i][2+buffer]-emas[i-1][3+buffer]);
         emas[i][4+buffer] = emas[i-1][4+buffer]+alpha*(emas[i][3+buffer]-emas[i-1][4+buffer]);
         emas[i][5+buffer] = emas[i-1][5+buffer]+alpha*(emas[i][4+buffer]-emas[i-1][5+buffer]);
      }
   return(c1*emas[i][5+buffer] + c2*emas[i][4+buffer] + c3*emas[i][3+buffer] + c4*emas[i][2+buffer]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

void manageAlerts()
{
   if (!calculateValue && alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] == 1) doAlert(whichBar,"up");
         if (trend[whichBar] ==-1) doAlert(whichBar,"down");
      }         
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," tf-",(Period())," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," HAMA trend changed to ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"HAMA "),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}